#ifndef MAPPER_H_INCLUDED
#define MAPPER_H_INCLUDED

typedef struct mmap_env {
    size_t size;
    size_t current_start;
    size_t current_end;
    char *map_start;
    int fd;
    char *filename;
} mmap_env;

mmap_env *mapper_init(int fd, char *filename);
char *get_in_mmap(mmap_env *env, size_t pos, size_t len, int force_update);

#endif
