#include "../lib/include/zmq.h"
#include "../lib/include/czmq.h"

#include "proxy-connector.h"

void connect_to_proxy(zctx_t *ctx) {
    void *zocket = zsocket_new(ctx, ZMQ_REQ);
    zsocket_connect(zocket, "ipc:///tmp/zmq-proxy-sync");
    zstr_send(zocket, "hello");

    char *rep = zstr_recv(zocket);
    assert(strcmp(rep, "go") == 0);
    free(rep);

    zsocket_disconnect(zocket, "ipc:///tmp/zmq-proxy-sync");
    zsocket_destroy(ctx, zocket);
}
